Tp::Client::CallContentMediaDescriptionInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::CallContentMediaDescriptionInterface Class Reference

`#include <TelepathyQt/CallContentMediaDescriptionInterface>`

Inherits Tp::AbstractInterface.

## Public Slots
QDBusPendingReply | Accept (const QVariantMap &localMediaDescription, int timeout=-1)
QDBusPendingReply | Reject (const Tp::CallStateReason &reason, int timeout=-1)

## Public Member Functions
| CallContentMediaDescriptionInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| CallContentMediaDescriptionInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| CallContentMediaDescriptionInterface (Tp::DBusProxy *proxy)
Tp::PendingVariant * | requestPropertyInterfaces () const
Tp::PendingVariant * | requestPropertyFurtherNegotiationRequired () const
Tp::PendingVariant * | requestPropertyHasRemoteInformation () const
Tp::PendingVariant * | requestPropertyCodecs () const
Tp::PendingVariant * | requestPropertyRemoteContact () const
Tp::PendingVariant * | requestPropertySSRCs () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions
static QLatin1String | staticInterfaceName ()

## Protected Member Functions
virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)
Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Call1.Content.MediaDescription".

## Constructor & Destructor Documentation

Tp::Client::CallContentMediaDescriptionInterface::CallContentMediaDescriptionInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentMediaDescriptionInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentMediaDescriptionInterface::CallContentMediaDescriptionInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallContentMediaDescriptionInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallContentMediaDescriptionInterface::CallContentMediaDescriptionInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a CallContentMediaDescriptionInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static QLatin1String Tp::Client::CallContentMediaDescriptionInterface::staticInterfaceName | ( |  | ) |
| inlinestatic

Returns the name of the interface "org.freedesktop.Telepathy.Call1.Content.MediaDescription", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertyInterfaces | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Interfaces` of type `QStringList`.

Extra interfaces provided by this media description. This SHOULD NOT include the Description interface itself.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertyFurtherNegotiationRequired | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `FurtherNegotiationRequired` of type `bool`.

If this is set to True by the CM in a MediaDescriptionOffer, it means "This is an offer under the SDP Offer/Answer model. Whatever you accept this offer with is what I will send to the other side in my answer." If this is set to False by the CM then it means "This is an Answer under the SDP Offer/Answer model, and if it remains False in the Accept(), no further codec negotiation needs to happen." If this is set to True by the streaming implementation (e.g. in an Accept or UpdateLocalMediaDescription call) then a new SDP Offer/Answer round-trip will be initiated.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertyHasRemoteInformation | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `HasRemoteInformation` of type `bool`.

True if this offer contains information from the remote side: If False then the Accept response solely depends on the capabilities and preferences of the local side. In most protocols this property will be False for the initial DescriptionOffer on an outgoing call.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertyCodecs | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Codecs` of type `Tp::CodecList`.

A list of codecs the remote contact supports. When used with Accept, it means the locally supported codecs.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertyRemoteContact | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `RemoteContact` of type `uint`.

The contact handle that this description applies to. This property can be used as an opaque identifier, and searched for in RemoteMembers for each Stream in this Content, to determine which Stream this MediaDescription applies to. If multiple MediaDescriptions apply to the same Stream, the SSRCs property should be used to separate media before decoding. If this property is 0, this MediaDescription applies to all streams, so the above matching method is unneccesary (e.g. in conference calls with a mixer, media from all participants is mixed into one stream). When calling Accept or UpdateLocalMediaDescription, this should always be set to 0, or omitted, because it is assumed that you send the same MediaDescription to everyone (Encoding a stream separately for each contact in a call is inefficient, and should be avoided).

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallContentMediaDescriptionInterface::requestPropertySSRCs | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `SSRCs` of type `Tp::ContactSSRCsMap`.

A map from Handle to list of Synchronisation Sources, as defined by RFC 3550.

Some protocols require the negotiation of SSRC identifiers for RTP streams. If this is the case, then MediaDescription offers will appear with this property set. The streaming implementation should then call Accept() with a map from 0 to a list containing a single SSRC (which does not collide with these, or any previously seen SSRCs). If a new MediaDescription offer appears with an SSRC the same as one in CallContentInterfaceMediaInterface::LocalMediaDescriptions , then the streaming implementation should pick a new SSRC to resolve the collision.

It is expected that this list will normally be at most one element long, but it is kept as a list for extensibility. The concatenation of all SSRCs associated with a Stream should contain no duplicate entries. If there are collisions, then it is the responsibility of the protocol implementation to resolve them and generate new offers.

If this property is omitted, then the streaming implementation can assume that there is only one MediaDescription per Stream.

If there is a single multicast Call Stream with multiple Remote Members, and all members are forced to use the same MediaDescription, this map can be used by the streaming implementation to determine which video sources belong to which contacts (e.g. in order to put a name under each face in the call)

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::CallContentMediaDescriptionInterface::requestAllProperties | ( |  | ) | const
| inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::CallContentMediaDescriptionInterface::Accept | ( | const QVariantMap & | localMediaDescription,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `Accept` on the remote object.

Accepts the updated Description and update the corresponding local description. If FurtherNegotiationRequired is True, calling this method will generally cause a network round-trip and a new MediaDescription to be offered (hopefully with FurtherNegotiationRequired set to False).

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  localMediaDescription |
      The local description to send to the remote contacts and to use in
      the Content.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallContentMediaDescriptionInterface::Reject | ( | const Tp::CallStateReason & | reason,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `Reject` on the remote object.

Reject the proposed update to the remote description.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  reason |
      A structured reason for the rejection.
  timeout | The timeout in milliseconds.

void Tp::Client::CallContentMediaDescriptionInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |
| protectedvirtual

Reimplemented from Tp::AbstractInterface.